

void write_ee_u8(u8 val, u8 storage[], u8 msize)
{
 for(u8 i=0;i<msize;i++)
 {
  if(storage[i]!=0xff)
  {
   if(storage[i]!=val)
   {
    FLASH_Unlock(FLASH_MEMTYPE_DATA);
    storage[i]=0xff;
    if(i<msize-1)storage[i+1] = val;
    else         storage[0]   = val;
    FLASH_Lock(FLASH_MEMTYPE_DATA);
   }
   return;
  }
 }
 FLASH_Unlock(FLASH_MEMTYPE_DATA);
 storage[0] = val; 
 FLASH_Lock(FLASH_MEMTYPE_DATA); 
}

u8 read_ee_u8(u8 storage[], u8 msize)
{
 for(u8 i=0;i<msize;i++)
 {
  if(storage[i]!=0xff)return storage[i];
 }
 return 0xff;   
}
