#define noc 2

volatile u8 kbtim; 
volatile enum {rls,prs,hold} btn[noc];
volatile bool btn_trg1;

void input(u16 &value, const u16 min_value, const u16 max_value, const u8 step, const u8 hstep, const u8 timer) 
{ 
 static bool btp0,btp1;  
   
 if(btn[0]!=rls && btn[1]!=rls){btp1=btp0=0;} 
 else if(btn[0]==rls && btn[1]==rls)btn_trg1=0; 
 
 if(btn[0]==prs && !btn_trg1) 
 { 
  btn_trg1=1; 
  btp0 = 1; 
 } 
 else if(btn[1]==prs &&! btn_trg1) 
 { 
  btn_trg1=1; 
  btp1 = 1; 
 } 
 else if(btn[0]==hold) 
 { 
  btp1=btp0=0; 
  if(!kbtim) 
  { 
   kbtim=timer; 
   if(value>min_value+hstep)value-=hstep; 
   else value=min_value; 
  } 
 } 
 else if(btn[1]==hold) 
 { 
  btp1=btp0=0; 
  if(!kbtim) 
  { 
   kbtim=timer; 
   if(value<max_value-hstep)value+=hstep; 
   else value=max_value; 
  }   
 } 

 if(!btn_trg1) 
 { 
  if(btp0) 
  { 
   btp1=btp0=0; 
   if(value>min_value+step)value-=step; 
   else value=min_value; 
  } 
  else if(btp1) 
  { 
   btp1=btp0=0;  
   if(value<max_value-step)value+=step;  
   else value=max_value;  
  }  
 }    
}
             
void scan_keys () 
{ 
#define lp  10 
#define lh  100
#define lr  5 

#if    noc==1 
#define key0   PF_IDR_IDR4 
#elif  noc==2
#define key0   PB_IDR_IDR7 
#define key1	 PB_IDR_IDR6  
#elif  noc==3
#define key0   PB_IDR_IDR7 
#define key1	 PB_IDR_IDR6 
#define key2	   
#endif 

 static u8 count[noc*3]; 
 u8 key_st[noc]; 

#if    noc==1 
 key_st[0] = key0; 
#elif  noc==2
 key_st[0] = key0; 
 key_st[1] = key1; 
#elif  noc==3
 key_st[0] = key0; 
 key_st[1] = key1; 
 key_st[2] = key2; 
#endif
 
 for(u8 i=0;i<noc;i++) 
 { 
  if (!key_st[i])
  {
   if (count[i*3]>lp) 
   {
    count[i*3]=0;
    
    if(btn[i]==rls)btn[i]=prs;
    if(count[i*3+1]>lh) {btn[i]=hold; count[i*3+1]=0;}
    else count[i*3+1]++;
   }
   else count[i*3]++;  
   
   count[i*3+2]=lr;
  } 
  else
  {
   if(count[i*3+2])count[i*3+2]--;
   else {count[i*3]=count[i*3+1]=0;btn[i]=rls;} 
  }  
 } 
} 

