
__no_init
struct
{
 u8 init;

 u8 airflow[30];
 u8 heatpow[30];
 u8 onoff[30];

} eep @ 0x4000;

class //periph_init
{
 public:

 void gpio()
 {
  PA_CR1 = 0xff;
  PA_ODR = 0;
  PA_DDR = 0;

  PB_CR1 = 1<<7|1<<6;
  PB_ODR = 0;
  PB_DDR = 0xff-(1<<7|1<<6);

  PC_CR1 = 0xff;
  PC_ODR = 0xff;
  PC_DDR = 0xff;

  PD_CR1 = 0xff-(1<<3);
  PD_ODR = 0;
  PD_DDR = 0xff-(1<<3|1<<1);

  PE_CR1 = 0xff;
  PE_ODR = 0;
  PE_DDR = 0xff;

  PF_CR1 = 0xff;
  PF_ODR = 0;
  PF_DDR = 0xff;
 }
 void clk()
 {
  CLK->PCKENR1 = CLK_PCKENR1_TIM1|CLK_PCKENR1_TIM2|CLK_PCKENR1_TIM4;
  CLK->PCKENR2 = 0;
  CLK->CKDIVR  = 0;
 }
 void t1()
 {
  TIM1->PSCRL = 15;
  TIM1->CCER1 = TIM1_CCER1_CC2E|TIM1_CCER1_CC1E;
  TIM1->CCER2 = TIM1_CCER2_CC4E|TIM1_CCER2_CC3E;
  TIM1->CCMR4 = TIM1->CCMR3 =TIM1->CCMR2 =TIM1->CCMR1 = force_active;
  TIM1->BKR   = TIM1_BKR_MOE;
  TIM1->CR1   = TIM1_CR1_CEN;
 }
 void t2()
 {
  TIM2->PSCR  = 4; // div16 -> 10000/10ms
  TIM2->CCMR2 = TIM2_ICSELECTION_DIRECTTI;
  TIM2->CCMR2|= 3<<4; //IC2f sampling=master, N=8;
  TIM2->IER   = TIM2_IER_CC2IE;
  TIM2->CCER1 = TIM2_CCER1_CC2P|TIM2_CCER1_CC2E;

  TIM2->CR1   = TIM2_CR1_CEN;
 }
 void t4()   //1000Hz
 {
  TIM4->ARR   = (u32)mcu_freq/128/1000-1;
  TIM4->PSCR  = 7;
  TIM4->IER   = 1;
  TIM4->CR1   = 1;
 }
 void iwdg()
 {
  IWDG_Enable();
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
  IWDG_SetPrescaler(IWDG_Prescaler_256);
  IWDG_SetReload(0xff);
  IWDG_ReloadCounter();
 }
 void ee()
 {
  #define initval 0xdb
  if(eep.init!=initval)
  {
   FLASH_Unlock(FLASH_MEMTYPE_DATA);
   eep.init = initval;

   eep.airflow[0]=9;
   eep.heatpow[0]=5;
   eep.onoff[0]  =1;

   FLASH_Lock(FLASH_MEMTYPE_DATA);
  }
 }
}cfg;

