#include <math.h>
#define PI 3.1415926

u8 powpos[10];

u8 set_angle(u8 angle) //180 - full power
{
 if(angle>170) angle=170;

 return 0xff-(u16)angle*0xff/180;
}

void calc_pw()
{
 for(u8 i=0;i<5;i++) powpos[i] = (u8)((float)90*sin((float)i*18*PI/2/90));

 for(u8 i=5;i<10;i++)
 {
  static u8 k=0;
  k++;
  powpos[i] = 180 - powpos[5-k];
 }
}

u8 set_pow (u8 pow) //9 - max power
{
 if(pow>9)pow=9;
 return set_angle(powpos[pow]);
}

